package cn.net.caoyao.cpzshandset.service.presenter.impl.setting.yunCar;

import java.util.ArrayList;
import java.util.List;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.os.Handler;
import android.widget.Toast;
import cn.net.caoyao.cpzshandset.bean.ConfigBean;
import cn.net.caoyao.cpzshandset.common.config.Config;
import cn.net.caoyao.cpzshandset.common.config.HandsetSettingOption;
import cn.net.caoyao.cpzshandset.common.config.HandsetVersionConstant;
import cn.net.caoyao.cpzshandset.common.config.RequestConstant;
import cn.net.caoyao.cpzshandset.service.bll.CarNoBll;
import cn.net.caoyao.cpzshandset.service.bll.config.ConfigBll;
import cn.net.caoyao.cpzshandset.service.presenter.SettingConstact;
import cn.net.caoyao.cpzshandset.service.presenter.base.impl.SettingConstactImpl;
import cn.net.caoyao.cpzshandset.service.thread.ThreadPoolManager;
import cn.net.caoyao.cpzshandset.service.thread.impl.yunCar.YunCarUpdateCarNoListThread;
import cn.net.caoyao.cpzshandset.ui.activity.DeviceIdConfigActivity;
import cn.net.caoyao.cpzshandset.ui.activity.ModifyHandsetVersionActivity;
import cn.net.caoyao.cpzshandset.ui.adapter.SettingAdapter;
import cn.net.caoyao.cpzshandset.ui.weight.DialogUtils;
import cn.net.cpzslibs.prot.handset.bean.res.Prot20001ResBean;
import cn.net.handsetlib.utils.ReadDeviceIDUtil;

public class YunCarSettingPresenter extends SettingConstactImpl{
	private final SettingConstact.View sView;
	private Context context;
	private List<HandsetSettingOption> beans = new ArrayList<HandsetSettingOption>();
	private ConfigBll configBll;
	private CarNoBll carNoBll;
	private ProgressDialog bProgressDialog = null;
	private int currentHandsetVersion = HandsetVersionConstant.HANDSET_YUN_CAR_VERSION_MODE;
	private Handler mHandler = new Handler(){
		public void handleMessage(android.os.Message msg) {
			switch (msg.what) {
			case RequestConstant.REQUEST_FAIL:
				//请求失败 
				if (!checkViewAvailable())return;
				dismissProgress();
				sView.showMsgToast("请求失败！", Toast.LENGTH_SHORT);
				break;
			case RequestConstant.REQUEST_FAIL_SOCKET_TIMEOUT:
				//超时
				if (!checkViewAvailable())return;
				dismissProgress();
				sView.showMsgToast("请求超时！", Toast.LENGTH_SHORT);
				break;
			case RequestConstant.REQUEST_PROT01_LOGIN_FAIL:
				//登录失败
				if (!checkViewAvailable())return;
				dismissProgress();
				String errorMsg = msg.obj.toString();
				int errorCode = msg.arg1;
				sView.showMsgToast(errorMsg + errorCode, Toast.LENGTH_SHORT);
				break;
			case RequestConstant.REQUEST_PRODUCT_LIST_SUCCESS:
				//请求车牌号信息成功
				if (!checkViewAvailable())return;
				dismissProgress();
				sView.showMsgToast("请求车牌号信息成功！", Toast.LENGTH_SHORT);
				break;
			case RequestConstant.REQUEST_PRODUCT_LIST_FAIL:
				//请求车牌号信息失败
				if (!checkViewAvailable())return;
				dismissProgress();
				Prot20001ResBean resBean = (Prot20001ResBean) msg.obj;
				sView.showMsgToast("请求失败 错误码：" + resBean.getErrcode(), Toast.LENGTH_SHORT);
				break;
			case RequestConstant.REQUEST_PRODUCT_LIST_IS_EMPTY:
				if (!checkViewAvailable())return;
				dismissProgress();
				String errorMsg1 = msg.obj.toString();
//				int errorCode1 = msg.arg1;
				sView.showMsgToast(errorMsg1, Toast.LENGTH_SHORT);
				break;
			}
		};
	};
	public YunCarSettingPresenter(SettingConstact.View sView,Context context) {
		this.sView = sView;
		this.context = context;
		start();
	}

	@Override
	public void start() {
		if (!checkViewAvailable()) return;
		configBll = new ConfigBll(context);
		initSettingData();
		SettingAdapter adapter = new SettingAdapter(beans);
		sView.setAdapter(adapter);
	}

	private void initSettingData() {
		beans.add(HandsetSettingOption.SETTING_CONFIG_DEVICE_ID_MODE);
		//beans.add(HandsetSettingOption.SETTING_UPDATE_CAR_LIST_MODE);
//		beans.add(new HomeBean(HandsetSettingOptionConstant.SETTING_CONFIG_DEVICE_ID_MODE, 0, "配置设备ID"));
//		beans.add(new HomeBean(HandsetSettingOptionConstant.SETTING_UPDATE_PRODUCT_LIST_MODE,0,"更新车牌号列表"));
		if (Config.canSwitchHandsetVersionMode) {
			beans.add(HandsetSettingOption.SETTING_HANDSET_MODE_SWITCH_MODE);
//			beans.add(new HomeBean(HandsetSettingOptionConstant.SETTING_HANDSET_MODE_SWITCH_MODE,0,"修改手持机版本模式"));
		}
	}

	@Override
	public boolean checkViewAvailable() {
		boolean b = false;
		if (sView != null && context != null) {
			b = true;
		}
		return b;
	}

	@Override
	public void onActivityResult(int requestCode, int resultCode, Intent data) {
		
	}

	@Override
	public Handler getHandler() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void onItemClickListener(int position) {
		swithSettingOption(beans.get(position));
	}
	public void dismissProgress() {
		if (bProgressDialog != null) {
			try {
				DialogUtils.dismissProgressDialog(bProgressDialog);
			} catch (Exception e) {
			}
		}
	}

	/**
	 * 提示正在更新数据
	 */
	protected void showProgressDialog(String titleStr, String tipsMsg) {
		bProgressDialog = DialogUtils.showProgressDialog(bProgressDialog, titleStr,
				tipsMsg, context);
	}
	private void swithSettingOption(HandsetSettingOption setOption) {
		switch (setOption) {
		case SETTING_HANDSET_MODE_SWITCH_MODE:
			//修改手持机版本模式
			Intent modifyVersionIntent = new Intent(context, ModifyHandsetVersionActivity.class);
			context.startActivity(modifyVersionIntent);
			
			break;
		case SETTING_CONFIG_DEVICE_ID_MODE:
			//配置设备ID
//			sView.showMsgToast("配置设备ID", Toast.LENGTH_SHORT);
			Intent intent = new Intent(context, DeviceIdConfigActivity.class);
			context.startActivity(intent);
			break;
		case SETTING_UPDATE_CAR_LIST_MODE:
			//更新车牌号列表
//			sView.showMsgToast("更新车牌号列表", Toast.LENGTH_SHORT);
			ConfigBean configBean = configBll.queryConfigByHandsetMode(currentHandsetVersion);
			if (configBean != null) {
				showProgressDialog("提示", "正在请求车牌号信息，请稍后……");
				 long deviceId = Long.parseLong(ReadDeviceIDUtil.readScanDecrypt(configBean.getDeviceId()));
				 ThreadPoolManager.getThreadPool().execute(new YunCarUpdateCarNoListThread(mHandler,deviceId,getCarNoBll()));
			} else {
				sView.showMsgToast("当前设备还未配置过手持机id，请先配置手持机的设备id", Toast.LENGTH_SHORT);
			}
			break;
		case SETTING_UPDATE_AGENCY_LIST_MODE:
			//更新经销商列表
			// TODO 通用版暂时未用到
			break;
		case SETTING_UPDATE_AUTHENTICITY_GUARANTEED_LIST_MODE:
			//更新正品保证单
			// TODO 通用版暂时未用到
			break;
		case SETTING_UPDATE_ADDRESS_LIST_MODE:
			//更新地址列表
			// TODO 通用版暂时未用到
			break;
		case SETTING_MODIFY_PWD_LIST_MODE:
			//修改登录密码
			// TODO 通用版暂时未用到
			break;
		}
	}


	private CarNoBll getCarNoBll() {
		if (carNoBll == null) {
			carNoBll = new CarNoBll(context);
		}
		return carNoBll;
	}

}
